using NiLang, NiLang.AD
using NiFunctions
using DelimitedFiles

data = readdlm("data/train.dat")

struct UnitaryFlow
    uparams::Vector
    aparams::Vector
end

function flow!(x, model::UnitaryFlow)
    for i=1:length(model.uparams)
        umm!(x, odel.uparams[i])
        umm!(x, odel.uparams[i])
    end
end

model = UnitaryFlow([randn()])

#using Flux: Optimise

function jacobian2(f, args; kwargs=())
    @assert count(x -> x isa Loss, args) == 1
    iloss = findfirst(x->x isa Loss, args)
    args = [x isa Loss ? x.x : x for x in args]

    f(args...; kwargs...)
    args = wrap_jacobian(Float64, args)
    (~f)(args...; kwargs...)
end


jacobian2(⊕(identity), (Loss(2.0), 3.0))
jacobian2(⊕(*), (Loss(2.0), 3.0, 2.0))
