
@i function ode_loss(μ, σ, field, xs::AbstractVector{TX}, loss_out::LT; Nt=Nt, dt=dt) where {LT,TX<:Dup}
    # backward run, drive target xs to source distribution space.
    # so that we can get `logp`.
    @anc anc_x = 0.0
    @safe println(loss_out)
    for i=1:length(xs)
        (~leapfrog)(field, xs[i]; Nt=Nt, dt=dt)
    end
    # then we evolve the `logp` to target space.
    PVar.(xs)
    for i=1:length(xs)
        anc_x ⊕ xs[i].x.x
        normal_logpdf(xs[i].x.logp, anc_x, μ, σ)
        anc_x ⊖ xs[i].x.x
        leapfrog(field, xs[i]; Nt=Nt, dt=dt)
        # with logp, we compute log-likelihood
        loss_out += xs[i].x.logp / length(xs)
    end
end
