export Dup

struct Dup{T} <: Bundle{T}
    x::T
    twin::T
end
function Dup(x::T) where T
   Dup{T}(x, copy(x))
end

@fieldview NiLangCore.value(x::Dup) = x.x
Base.isapprox(a::Dup, b::Dup; kwargs...) = isapprox(a.x, b.x; kwargs...) && isapprox(a.twin, b.twin; kwargs...)

NiLangCore.ADCore.GVar(x::Dup) = Dup(GVar(x.x), GVar(x.twin))
(invg::Type{Inv{GVar}})(x::Dup) = Dup(invg(x.x), invg(x.twin))

Base.zero(::Dup{T}) where T = Dup(zero(T))
Base.zero(::Type{Dup{T}}) where T = Dup(zero(T))
function Base.show(io::IO, obj::Bundle)
    vals = getproperty.(Ref(obj), fieldnames(typeof(obj)))
    print(io, "$(typeof(obj).name)$vals")
end

# the integrater
@i function leapfrog(field, x::Dup; Nt::Int, dt::Float64)
    @safe isreversible(field) || throw(InvertibilityError("Input function $field is not reversible."))
    # move ks for half step
    update_field(field, x.twin, x.x; dt=dt/2)
    for i=1:Nt
        update_field(field, x.x, x.twin; dt=dt)
        update_field(field, x.twin, x.x; dt=dt)
    end
end


