using InvOde
using Test

@testset "InvOde.jl" begin
    # Write your own tests here.
end


@testset "neural ode"
    # integrate sin(θ), get -log(det(∂cos(θ)/∂θ))
    lf = LinearField(0.5)
    x = PVar(0.8)
    truth = value(x)
    for i=1:1000
        truth += 0.001*truth*lf.θ
    end
    @instr Dup(x)
    @test check_inv(leapfrog, (lf, x); kwargs=(Nt=1000, dt=0.001))
    @instr NiFunctions.leapfrog(lf, x; Nt=1000, dt=0.001)
    @test isapprox(value(x), truth; atol=1e-3)
    @test isapprox(x.x.logp, -0.5, atol=1e03) # TODO: manual check
end


